#include "Ultrasonic.h"
#define echoPin 13 
#define trigPin 12 
#define speed_A 100
#define speed_B 160 //motor direito
#define STOP 20


#define IN1 4 //pinos de rotação
#define IN2 5 
#define IN3 6
#define IN4 7
#define SPDIN1 10 //controle de velocidade do motor A
#define SPDIN2 3 //controle de velocidade do motor B
#define TRIN 11 //track input
#define melodyPin 2
#define WHITE HIGH
#define BLACK LOW

void moveCar(void);
void stopCar(int n);
void followTrack(int dir);
int turnAround(void);
void seekTrack(void);
int isBlocked(void);
int turnAround(void);
void initMov(int startdir);

void setup() {
  Serial.begin(9600);
  initMov(1);
  
  pinMode(TRIN, INPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  pinMode(SPDIN1, OUTPUT);
  pinMode(SPDIN2, OUTPUT);  
  pinMode(echoPin, INPUT); 
  pinMode(trigPin, OUTPUT); 

  pinMode(melodyPin, OUTPUT);

  return;
}

int stoped = 0;
int block = 0;
int following = 1;
Ultrasonic ultrasonic(12, 13);

int thisNote = 0;
int thisMelody = 1;

void loop() {
 block = isBlocked(STOP);
 //Serial.println(block);
 digitalWrite(melodyPin, HIGH);
 if(block == 1){
    block = turnAround();
 }  
 if(block == 0) {
   digitalWrite(melodyPin, LOW);
   moveCar();
 } 
 
 //sing(thisMelody);

  return;
}

int dir_change;
int left; //0 esquerda, 1 direita

void initMov(int startdir) {
  dir_change = 1;
  left = startdir;    
  return; 
}

void moveCar(void) {
   int track = digitalRead(TRIN);
   
   if(track == WHITE && dir_change) {
     dir_change = 0;
     left = 1 - left;
     stopCar(10);
   }
   else if(track == BLACK) {
     dir_change = 1;
     //counter++;
   }
   followTrack(left);

   return;
}

void stopCar(int n) {
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, HIGH); 
    delay(n);
    return;
}

void followTrack(int dir) {  
  if(dir) {
    //Serial.println("bolsonaro"); //essa roda tá fraca
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    analogWrite(SPDIN1, 125); //120 funciona travando, mas funciona
    analogWrite(SPDIN2, 50); //45 funciona travando, mas funciona
  }
  else {
   //Serial.println("jean wyllys");
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    analogWrite(SPDIN2, 95); //70 funciona travando, mas funciona
    analogWrite(SPDIN1, 70); //60 funciona travando, mas funciona
  }  
  
  return;
}

int isBlocked(int dist){
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  
  static float ocorrencia = 0;
  int distancia = (ultrasonic.Ranging(CM));
    
  if(distancia >= 12 && distancia  <= dist){
    ocorrencia++;
  }
  else {
    ocorrencia = 0;
  }
  
  if(ocorrencia >= 50) {
    return 1;
  }
  
  return 0;
}

int turnAround(void){
  //abre ângulo à esquerda
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, HIGH);
  analogWrite(SPDIN1, 200);
  delay(450); 
  stopCar(500);
  
  //faz curva
  do {
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    analogWrite(SPDIN1, 70);
    analogWrite(SPDIN2, 95);    
  } while(digitalRead(TRIN) == WHITE);
  stopCar(500);

  initMov(0);
    
  return 0;
}
